unit CallerDefs;


interface


Const
//----- CAPI commands
  CAPI_ALERT = $1;
  CAPI_CONNECT = $2;
  CAPI_CONNECT_ACTIVE = $3;
  CAPI_CONNECT_B3_ACTIVE = $83;
  CAPI_CONNECT_B3 = $82;
  CAPI_CONNECT_B3_T90_ACTIVE = $88;
  CAPI_DATA_B3 = $86;
  CAPI_DISCONNECT_B3 = $84;
  CAPI_DISCONNECT = $4;
  CAPI_FACILITY = $80;
  CAPI_INFO = $8;
  CAPI_LISTEN = $5;
  CAPI_MANUFACTURER = $FF;
  CAPI_RESET_B3 = $87;
  CAPI_SELECT_B_PROTOCOL = $41;

//'----- CAPI subcommands
  CAPI_REQ = $80;
  CAPI_CONF = $81;
  CAPI_IND = $82;
  CAPI_RESP = $83;

// Call_resp
  CALL_RESP_ACCEPT = 0;          // accept
  CALL_RESP_IGNORE = 1;          // ignore
  CALL_RESP_CLEAR = 2;           // reject
  CALL_RESP_BUSY = 3;            // reject
  CALL_RESP_NA = 4;              // reject
  CALL_RESP_FACILITYRECJECT = 5; // reject
  CALL_RESP_CHANNEL = 6;         // reject
  CALL_RESP_INCOMPATIBLE = 7;    // reject
  CALL_RESP_OUTOFORDER = 8;      // reject

// info masks for the ListenReq */

  InfoMask_CAUSE = 1;
  InfoMask_DATETIME = 2;
  InfoMask_DISPLAY = 4;
  InfoMask_USERUSER = 8;
  InfoMask_CALLPROGRESS = 16;
  InfoMask_FACILITY = 32;
  InfoMask_CHARGING = 64;
  InfoMask_ALL = 1023;

// CIP masks and CIP values */
  
  CIPMask_ALL_SERVICES = $1FFF03FF;
  CIPMask_NONE = 0;
  CIPMask_ALL = 1;
  CIPMask_SPEECH = 2;
  CIPMask_UNRESTRICTEDDIGITAL = 4;
  CIPMask_RESTRICTEDDIGITAL = 8;
  CIPMask_31KHZAUDIO = 16;
  CIPMask_7KHZAUDIO = 32;
  CIPMask_VIDEO = 64;
  CIPMask_PACKETMODE = 128;
  CIPMask_56KBIT = 256; //2 ^ 8
  CIPMask_TELEPHONY = $10000; //2 ^ 16
  CIPMask_FAXG3 = $20000;  //2 ^ 17
  CIPMask_FAXG4 = $40000; //2 ^ 18
  CIPMask_TELETEXBASICMIXED = $80000; //2 ^ 19
  CIPMask_TELETEXBASICPROCESSABLE = $100000; //2 ^ 20
  CIPMask_TELETEXBASIC = $200000; //2 ^ 21
  CIPMask_VIDEOTEX = $400000; //2 ^ 22
  CIPMask_TELEX = $800000; //2 ^ 23
  CIPMask_X400 = $1000000; //2 ^ 24
  CIPMask_OSIX200 = $2000000; //2 ^ 25
  CIPMask_7KHZTELEPHONY = $4000000; //2 ^ 26
  CIPMask_VIDEOTELEPHONY_FIRST = $8000000; //2 ^ 27
  CIPMask_VIDEOTELEPHONY_SECOND = $10000000; //2 ^ 28

  CIPValue_UNDEFINED = 0;
  CIPValue_ALL = 0;
  CIPValue_SPEECH = 1;
  CIPValue_UNRESTRICTEDDIGITAL = 2;
  CIPValue_RESTRICTEDDIGITAL = 3;
  CIPValue_31KHZAUDIO = 4;
  CIPValue_7KHZAUDIO = 5;
  CIPValue_VIDEO = 6;
  CIPValue_PACKETMODE = 7;
  CIPValue_56KBIT = 8;
  CIPValue_TELEPHONY = 16;
  CIPValue_FAXG3 = 17;
  CIPValue_FAXG4 = 18;
  CIPValue_TELETEXBASICMIXED = 19;
  CIPValue_TELETEXBASICPROCESSABLE = 20;
  CIPValue_TELETEXBASIC = 21;
  CIPValue_VIDEOTEX = 22;
  CIPValue_TELEX = 23;
  CIPValue_X400 = 24;
  CIPValue_OSIX200 = 25;
  CIPValue_7KHZTELEPHONY = 26;
  CIPValue_VIDEOTELEPHONY_FIRST = 27;
  CIPValue_VIDEOTELEPHONY_SECOND = 28;
  
//---- Generall
  Headerlength = 8;
    
  
type 

  TVersion = record
    CapiMajor,
    CapiMinor,
    ManufacturerMajor,
    ManufacturerMinor: LongInt;
  end;  
  
  TListenREQ = record
    Lengte         : Smallint;
    ApplId         : Smallint;
    Command        : Byte;
    SubCommand     : Byte;
    Message_number : Smallint;
    Controller     : LongInt;
    InfoMask       : LongInt;
    CIPMask        : LongInt;
    CIPMas2        : LongInt;
    CallingParty   : Byte;
    CallingPartySub: Byte;
  end;     

  TMessageHeader = record
    length        : SmallInt;
    Appid         : SmallInt;
    Command       : Byte;
    SubCommand    : Byte;
    Message_Number: SmallInt;
  end;

  TConnectInd = record
    PLCI  : integer;
    CIP   : SmallInt;
    Buffer: array[0..99] of char;
  end;
  
  TAlertREQ = record
    length        : SmallInt;
    Applid        : SmallInt;
    Command       : Byte;
    SubCommand    : Byte;
    Message_Number: SmallInt;
    //Header end -------
    PLCI          : integer;
    //ab hier immer 0 eintragen
    BCI           : SmallInt;
    kpf           : Byte;
    uud           : Byte;
    fda           : Byte;
  end;

  TConnectResp = record
    Length             : SmallInt;
    Applid             : SmallInt;
    Command            : Byte;
    SubCommand         : Byte;
    Message_Number     : SmallInt;
    PLCI               : integer;
    REJECT             : SmallInt; 
    BProtocol          : Integer;
    ConnectedNumber    : Integer;
    ConnectedSubaddress: Integer;
    LLC                : Integer;
    AdditionalInfo     : Integer;
  end;

// INFOIND Struct - c &H8 s &H82
  TInfoInd = record
    PLCI         : integer;
    InfoNumberLSB: Byte;
    InfoNumerbMSB: Byte;
    InfoElement  : array[0..99] of Byte;
  end;

// INFORESP Struct - c &H8 s &H83
  TInfoResp = record
    Length        : SmallInt;
    Applid        : SmallInt;
    Command       : Byte;
    SubCommand    : Byte;
    Message_Number: SmallInt;
    PLCI            : Integer;
  end;  

// DISCONNECTIND Struct - c &H4 s &H82

  TDisconnectInd = record
    PLCI  : Integer;
    Reason: SmallInt;
  end;  

// DISCONNECTRESP Struct - c &H4 s &H83
  TDisconnectResp = record
    Length        : SmallInt;
    Applid        : SmallInt;
    Command       : Byte;
    SubCommand    : Byte;
    Message_Number: SmallInt;
    PLCI          : Integer;
  end;  

implementation

end.

